TW.IDE.Widgets.d3timeseries = function () {

	this.MAX_SERIES = 16;
	this.widgetIconUrl = function () {
		return "../Common/extensions/d3timeseries/ui/d3timeseries/d3timeseries.jpg";
	};
	this.widgetProperties = function () {
		var properties = {
			'name': 'd3timeseries Widget',
			'description': 'd3timeseries widget',
			'category': ['Common'],
			'iconImage': 'd3timeseries.jpg',
			'isExtension': true,
			'supportsAutoResize': true,
			'borderWidth': 1,
            'defaultBindingTargetProperty': 'Data',
            'supportsTooltip': true,
			'properties': {
                'CustomClass': {
                    'description': 'Custom Class',
                    'baseType': 'STRING',
                    'isLocalizable': false,
                    'isBindingSource': true,
                    'isBindingTarget': true,
                    'isVisible': false
                },
                'SingleDataSource': {
                    'description': 'Use a Single Data Source for All Series',
                    'defaultValue': true,
                    'baseType': 'BOOLEAN',
                    'isVisible': true
                },
                'NumberOfSeries': {
                    'description': 'Desired number of series in this chart',
                    'defaultValue': 8,
                    'baseType': 'NUMBER',
                    'isVisible': true
                },
                'Data': {
                    'description': 'Data source',
                    'isBindingTarget': true,
                    'isEditable': false,
                    'baseType': 'INFOTABLE',
                    'warnIfNotBoundAsTarget': true
                },
				'XLegendTitle': {
					'baseType': 'STRING',
					'defaultValue': 'X Title',
					'isBindingTarget': true
				},
				'YLegendTitle': {
					'baseType': 'STRING',
					'defaultValue': 'Y Title',
					'isBindingTarget': true
				},
				'TopMargin': {
					'baseType': 'INTEGER',
					'defaultValue': 30,
					'isBindingTarget': true
				},
				'BottomMargin': {
					'baseType': 'INTEGER',
					'defaultValue': 50,
					'isBindingTarget': true
				},
				'LeftMargin': {
					'baseType': 'INTEGER',
					'defaultValue': 100,
					'isBindingTarget': true
				},
				'RightMargin': {
					'baseType': 'INTEGER',
					'defaultValue': 100,
					'isBindingTarget': true
				},
                'ChartType': {
                    'description': 'Chart Type',
                    'baseType': 'STRING',
                    'defaultValue': 'marker',
                    'isVisible' : false
                },
                'ChartOrientation': {
                    'description': 'Chart Orientation',
                    'baseType': 'STRING',
                    'defaultValue': 'vertical',
                    'isVisible' : false
                },
                'ChartStyle': {
                    'description': 'Chart overall style',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartStyle'
                },
                'ChartAreaStyle': {
                    'description': 'Chart area style',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartAreaStyle'
                },
                'ChartLegendStyle': {
                    'description': 'Chart legend style',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartLegendStyle'
                },
                'ChartTitleStyle': {
                    'description': 'Chart title style',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartTitleStyle'
                },
                'SelectedItemStyle': {
                    'description': 'Selected item style',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartSelectionStyle'
                },
                'ChartTitle': {
                    'description': 'Chart Title',
                    'baseType': 'STRING',
                    'isBindingTarget': true,
                    'defaultValue': '',
                    'isLocalizable': true
                },
                'ShowLegend': {
                    'description': 'Show or hide the legend',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'LegendWidth': {
                    'description': 'Legend Width',
                    'baseType': 'NUMBER',
                    'defaultValue': 0
                },
                'LegendLocation': {
                    'description': 'Legend Location',
                    'baseType': 'STRING',
                    'defaultValue': 'right',
                    'selectOptions': [
                        { value: 'right', text: 'right'},
                        { value: 'top', text: 'top'},
                        { value: 'bottom', text: 'bottom'},
                        { value: 'left', text: 'left'}
                    ]
                },
                'LegendOrientation': {
                    'description': 'Legend Orientation',
                    'baseType': 'STRING',
                    'defaultValue': 'vertical',
                    'selectOptions': [
                        { value: 'vertical', text: 'vertical' },
                        { value: 'horizontal', text: 'horizontal' }
                    ]
                },
                'MarkerSize': {
                    'description': 'Marker Size',
                    'baseType': 'NUMBER',
                    'defaultValue': 3
                },
                'MarkerType': {
                    'description': 'Marker Type',
                    'baseType': 'STRING',
                    'defaultValue': 'circle',
                    'selectOptions': [
                        { value: 'circle', text: 'circle'},
                        { value: 'square', text: 'square'},
                        { value: 'triangle', text: 'triangle'},
                        { value: 'diamond', text: 'diamond'},
                        { value: 'image', text: 'image'}
                    ]
                },
                'DrawLine': {
                    description:  'Enable or disable line drawing to connect the points in XY chart',
                    baseType:     'BOOLEAN',
                    defaultValue: false
                },
                'XAxisField': {
                    'description': 'XAxisField',
                    'baseType': 'FIELDNAME',
                    'sourcePropertyName': 'Data',
                    'isBindingTarget': false,
                    'baseTypeRestriction': 'NUMBER',
                    'isVisible': true
                },
                'ShowXAxis': {
                    'description': 'ShowXAxis',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'XAxisStyle': {
                    'description': 'XAxisStyle',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartAxisStyle'
                },
                'XAxisFormat': {
                    'description': 'XAxisFormat',
                    'baseType': 'STRING',
                    'defaultValue' : '0000.0'
                },
                'XAxisMinimum': {
                    'isBindingTarget': true,
                    'isVisible': true,
                    'description': 'XAxisMinimum',
                    'baseType': 'NUMBER'
                },
                'XAxisMaximum': {
                    'isBindingTarget': true,
                    'isVisible': true,
                    'description': 'XAxisMaximum',
                    'baseType': 'NUMBER'
                },
                'XAxisAutoscale': {
                    'isVisible': true,
                    'description': 'XAxisAutoscale',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'XAxisZeroscale': {
                    'isVisible': true,
                    'description': 'XAxisZeroscale',
                    'baseType': 'BOOLEAN',
                    'defaultValue': false
                },
                'XAxisSmoothScaling': {
                    'isVisible': true,
                    'description': 'XAxisSmoothScaling',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'XAxisIntervals': {
                    'description': 'XAxisIntervals',
                    'baseType': 'NUMBER',
                    'defaultValue': 10
                },
                'XAxisMinorTicks': {
                    'description': 'XAxisMinorTicks',
                    'baseType': 'NUMBER',
                    'defaultValue': 1
                },
                'XAxisLabels': {
                    'description': 'XAxisLabels',
                    'baseType': 'NUMBER',
                    'defaultValue': 2
                },
                'ShowXAxisLabels': {
                    'description': 'ShowXAxisLabels',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'ShowXAxisTicks': {
                    'description': 'ShowXAxisTicks',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'AllowXAxisZoom': {
                    'description': 'AllowXAxisZoom',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'ShowYAxis': {
                    'description': 'ShowYAxis',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'YAxisMode': {
                    'description':  'YAxisMode',
                    'baseType': 'STRING',
                    'defaultValue': 'single',
                    'isVisible' : true,
                    'selectOptions': [
                        { value: 'single', text: 'Single Y Axis' },
                        { value: 'dual', text: 'Dual Y Axes' },
                        { value: 'multi', text: 'Multi Y Axes' }
                    ]
                },
                'YAxisStyle': {
                    'description': 'YAxisStyle',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartAxisStyle'
                },
                'YAxisIntervals': {
                    'description': 'YAxisIntervals',
                    'baseType': 'NUMBER',
                    'defaultValue': 10
                },
                'YAxisMinorTicks': {
                    'description': 'YAxisMinorTicks',
                    'baseType': 'NUMBER',
                    'defaultValue': 1
                },
                'YAxisLabels': {
                    'description': 'YAxisLabels',
                    'baseType': 'NUMBER',
                    'defaultValue': 2
                },
                'ShowYAxisLabels': {
                    'description': 'ShowYAxisLabels',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'ShowYAxisTicks': {
                    'description': 'ShowYAxisTicks',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'AllowYAxisZoom': {
                    'description': 'AllowYAxisZoom',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'YAxisFormat': {
                    'description': 'YAxisFormat',
                    'baseType': 'STRING',
                    'defaultValue' : '0000.0'
                },
                'YAxisMinimum': {
                    'isBindingTarget': true,
                    'isVisible': true,
                    'description': 'YAxisMinimum',
                    'baseType': 'NUMBER',
                    'defaultValue': 0.0
                },
                'YAxisMaximum': {
                    'isBindingTarget': true,
                    'isVisible': true,
                    'description': 'YAxisMaximum',
                    'baseType': 'NUMBER',
                    'defaultValue': 100.0
                },
                'YAxisAutoscale': {
                    'description': 'YAxisAutoscale',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'YAxisZeroscale': {
                    'isVisible': true,
                    'description': 'YAxisZeroscale',
                    'baseType': 'BOOLEAN',
                    'defaultValue': false
                },
                'SecondaryYAxisFormat': {
                    'description': 'SecondaryYAxisFormat',
                    'baseType': 'STRING',
                    'defaultValue' : '0000.0'
                },
                'SecondaryYAxisMinimum': {
                    'isBindingTarget': true,
                    'isVisible': true,
                    'description': 'SecondaryYAxisMinimum',
                    'baseType': 'NUMBER',
                    'defaultValue': 0.0
                },
                'SecondaryYAxisMaximum': {
                    'isBindingTarget': true,
                    'isVisible': true,
                    'description': 'SecondaryYAxisMaximum',
                    'baseType': 'NUMBER',
                    'defaultValue': 100.0
                },
                'SecondaryYAxisAutoscale': {
                    'description': 'SecondaryYAxisAutoscale',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'SecondaryYAxisZeroscale': {
                    'isVisible': true,
                    'description': 'SecondaryYAxisZeroscale',
                    'baseType': 'BOOLEAN',
                    'defaultValue': false
                },
                'AllowSelection': {
                    'description': 'AllowSelection',
                    'baseType': 'BOOLEAN',
                    'isVisible': true,
                    'defaultValue': true
                },
                'EnableHover': {
                    'description': 'EnableHover',
                    'baseType': 'BOOLEAN',
                    'isVisible': true,
                    'defaultValue': true
                },
                'ShowXAxisGrid': {
                    'description': 'ShowXAxisGrid',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'ShowYAxisGrid': {
                    'description': 'ShowYAxisGrid',
                    'baseType': 'BOOLEAN',
                    'defaultValue': true
                },
                'GridStyle': {
                    'description': 'GridStyle',
                    'baseType': 'STYLEDEFINITION',
                    'defaultValue': 'DefaultChartGridStyle'
                },
                'Width': {
                    'defaultValue': 640,
                    'description': 'Width'
                },
                'Height': {
                    'defaultValue': 240,
                    'description': 'Height'
                }
			}
		};


	var seriesNumber;
        for (seriesNumber = 1; seriesNumber <= this.MAX_SERIES; seriesNumber++) {
            var datasetProperty = {
                'description': 'datasetProperty' + seriesNumber,
                'isBindingTarget': true,
                'isEditable': false,
                'baseType': 'INFOTABLE',
                'warnIfNotBoundAsTarget': false,
                'isVisible': true
            };

            var datalabelProperty = {
                'description': 'datalabelProperty' + seriesNumber,
                'baseType': 'STRING',
                'isBindingTarget': true,
                'isVisible': true,
                'isLocalizable': true
            };

            var datafieldProperty = {
                'description': 'datafieldProperty' + seriesNumber,
                'baseType': 'FIELDNAME',
                'sourcePropertyName': 'Data',
                'isBindingTarget': false,
                'baseTypeRestriction': 'NUMBER',
                'isVisible': true
            };

            var xaxisfieldProperty = {
                'description': 'xaxisfieldProperty' + seriesNumber,
                'baseType': 'FIELDNAME',
                'sourcePropertyName': 'Data',
                'isBindingTarget': false,
                'baseTypeRestriction': 'NUMBER',
                'isVisible': true
            };

            var seriestypeProperty = {
                'description': 'seriestypeProperty',
                'baseType': 'STRING',
                'defaultValue' : 'chart',
                'selectOptions': [
                    { value: 'chart', text: 'chart' },
                    { value: 'line', text: 'line' },
                    { value: 'linemarker', text: 'linemarker' },
                    { value: 'marker', text: 'marker' }
                ]
            };
            
            var seriesmarkertypeProperty = {
                'description': 'seriesmarkertypeProperty',
                'baseType': 'STRING',
                'defaultValue': 'chart',
                'selectOptions': [
                    { value: 'chart', text: 'chart' }
                ]
            };
                
            var seriesStyleProperty = {
                'description': 'seriesStyleProperty' + seriesNumber,
                'baseType': 'STYLEDEFINITION',
                'isVisible': true
            };

            var seriesDataStyleProperty = {
                'description': 'seriesDataStyleProperty' + seriesNumber,
                'baseType': 'STATEFORMATTING',
                'baseTypeInfotableProperty': 'Data',
                'isVisible': true
            };

            var seriesUseSecondaryYAxisProperty = {
                'description': 'seriesUseSecondaryYAxisProperty',
                'baseType': 'BOOLEAN',
                'defaultValue' : false,
                'isVisible' : true
            };
                    
            var seriescustomAxisFormatProperty = {
                'description': 'seriescustomAxisFormatProperty',
                'baseType': 'STRING',
                'defaultValue' : '0000.0',
                'isVisible' : false
            };
            
            var seriescustomAxisMinimumProperty = {
                'isBindingTarget': true,
                'isVisible': true,
                'description': 'seriescustomAxisMinimumProperty',
                'baseType': 'NUMBER',
                'defaultValue': 0.0,
                'isVisible' : false
            };
            
            var seriescustomAxisMaximumProperty = {
                'isBindingTarget': true,
                'isVisible': true,
                'description': 'seriescustomAxisMaximumProperty',
                'baseType': 'NUMBER',
                'defaultValue': 100.0,
                'isVisible' : false
            };
            
            var seriescustomAxisAutoscaleProperty = {
                'description': 'seriescustomAxisAutoscaleProperty',
                'baseType': 'BOOLEAN',
                'defaultValue': true,
                'isVisible' : false
            };
            
            var seriescustomAxisZeroscaleProperty = {
                'isVisible': true,
                'description': 'seriescustomAxisZeroscaleProperty',
                'baseType': 'BOOLEAN',
                'defaultValue': false,
                'isVisible' : false
            };
            
            properties.properties['DataSource' + seriesNumber] = datasetProperty;
            properties.properties['DataField' + seriesNumber] = datafieldProperty;
            properties.properties['DataLabel' + seriesNumber] = datalabelProperty;
            properties.properties['XAxisField' + seriesNumber] = xaxisfieldProperty;
            properties.properties['SeriesType' + seriesNumber] = seriestypeProperty;
            properties.properties['SeriesMarkerType' + seriesNumber] = seriesmarkertypeProperty;
            properties.properties['UseSecondaryAxis' + seriesNumber] = seriesUseSecondaryYAxisProperty;
            properties.properties['AxisFormat' + seriesNumber] = seriescustomAxisFormatProperty;
            properties.properties['AxisMinimum' + seriesNumber] = seriescustomAxisMinimumProperty;
            properties.properties['AxisMaximum' + seriesNumber] = seriescustomAxisMaximumProperty;
            properties.properties['AxisAutoscale' + seriesNumber] = seriescustomAxisAutoscaleProperty;
            properties.properties['AxisZeroscale' + seriesNumber] = seriescustomAxisZeroscaleProperty;
            properties.properties['SeriesStyle' + seriesNumber] = seriesStyleProperty;
            properties.properties['SeriesStyle' + seriesNumber]['defaultValue'] = 'DefaultChartStyle' + seriesNumber;
            properties.properties['SeriesDataStyle' + seriesNumber] = seriesDataStyleProperty;
        }

        return properties;
	};
	
	this.setSeriesAxisProperties = function(value) {
        var allWidgetProps = this.allWidgetProperties();

        var mode = this.getProperty('YAxisMode');
        
        var seriesNumber;

        if(mode == 'multi') {
            for (seriesNumber = 1; seriesNumber <= value; seriesNumber++) {
                allWidgetProps['properties']['UseSecondaryAxis' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisFormat' + seriesNumber]['isVisible'] = true;
                allWidgetProps['properties']['AxisMinimum' + seriesNumber]['isVisible'] = true;
                allWidgetProps['properties']['AxisMaximum' + seriesNumber]['isVisible'] = true;
                allWidgetProps['properties']['AxisAutoscale' + seriesNumber]['isVisible'] = true;
                allWidgetProps['properties']['AxisZeroscale' + seriesNumber]['isVisible'] = true;
            }
            for (seriesNumber = value + 1; seriesNumber <= this.MAX_SERIES; seriesNumber++) {
                allWidgetProps['properties']['UseSecondaryAxis' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisFormat' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMinimum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMaximum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisAutoscale' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisZeroscale' + seriesNumber]['isVisible'] = false;
            }
        }
        else if(mode == 'dual') {
            for (seriesNumber = 1; seriesNumber <= value; seriesNumber++) {
                allWidgetProps['properties']['UseSecondaryAxis' + seriesNumber]['isVisible'] = true;
                allWidgetProps['properties']['AxisFormat' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMinimum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMaximum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisAutoscale' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisZeroscale' + seriesNumber]['isVisible'] = false;
            }
            for (seriesNumber = value + 1; seriesNumber <= this.MAX_SERIES; seriesNumber++) {
                allWidgetProps['properties']['UseSecondaryAxis' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisFormat' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMinimum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMaximum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisAutoscale' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisZeroscale' + seriesNumber]['isVisible'] = false;
            }
        }
        else {
            for (seriesNumber = 1; seriesNumber <= value; seriesNumber++) {
                allWidgetProps['properties']['UseSecondaryAxis' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisFormat' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMinimum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMaximum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisAutoscale' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisZeroscale' + seriesNumber]['isVisible'] = false;
            }
            for (seriesNumber = value + 1; seriesNumber <= this.MAX_SERIES; seriesNumber++) {
                allWidgetProps['properties']['UseSecondaryAxis' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisFormat' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMinimum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisMaximum' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisAutoscale' + seriesNumber]['isVisible'] = false;
                allWidgetProps['properties']['AxisZeroscale' + seriesNumber]['isVisible'] = false;
            }
        }
    };
    
    this.setSeriesProperties = function (value, singleSource) {
        var allWidgetProps = this.allWidgetProperties();

        var seriesNumber;

        for (seriesNumber = 1; seriesNumber <= value; seriesNumber++) {
            allWidgetProps['properties']['DataField' + seriesNumber]['isVisible'] = true;
            allWidgetProps['properties']['DataSource' + seriesNumber]['isVisible'] = !singleSource;
            allWidgetProps['properties']['XAxisField' + seriesNumber]['isVisible'] = !singleSource;
            allWidgetProps['properties']['SeriesStyle' + seriesNumber]['isVisible'] = true;
            allWidgetProps['properties']['SeriesType' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['SeriesMarkerType' + seriesNumber]['isVisible'] = true;
            allWidgetProps['properties']['SeriesDataStyle' + seriesNumber]['isVisible'] = true;
            allWidgetProps['properties']['DataLabel' + seriesNumber]['isVisible'] = true;
        }

        for (seriesNumber = value + 1; seriesNumber <= this.MAX_SERIES; seriesNumber++) {
            allWidgetProps['properties']['DataField' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['DataSource' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['XAxisField' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['SeriesStyle' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['SeriesType' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['SeriesMarkerType' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['SeriesDataStyle' + seriesNumber]['isVisible'] = false;
            allWidgetProps['properties']['DataLabel' + seriesNumber]['isVisible'] = false;
        }

        if (singleSource) {
            for (seriesNumber = 1; seriesNumber <= this.MAX_SERIES; seriesNumber++) {
                allWidgetProps['properties']['DataField' + seriesNumber]['sourcePropertyName'] = 'Data';
                allWidgetProps['properties']['XAxisField' + seriesNumber]['sourcePropertyName'] = 'Data';
                allWidgetProps['properties']['SeriesDataStyle' + seriesNumber]['baseTypeInfotableProperty'] = 'Data';
            }

            allWidgetProps['properties']['Data']['isVisible'] = true;
            allWidgetProps['properties']['XAxisField']['isVisible'] = true;
        }
        else {
            for (seriesNumber = 1; seriesNumber <= this.MAX_SERIES; seriesNumber++) {
                allWidgetProps['properties']['DataField' + seriesNumber]['sourcePropertyName'] = 'DataSource' + seriesNumber;
                allWidgetProps['properties']['XAxisField' + seriesNumber]['sourcePropertyName'] = 'DataSource' + seriesNumber;
                allWidgetProps['properties']['SeriesDataStyle' + seriesNumber]['baseTypeInfotableProperty'] = 'DataSource' + seriesNumber;
            }
            allWidgetProps['properties']['Data']['isVisible'] = false;
            allWidgetProps['properties']['XAxisField']['isVisible'] = false;
        }
    };

    this.widgetEvents = function () {
        return {
        	'DoubleClicked': {}
        };
    };

	this.renderHtml = function () {
		var html = '';
        html += '<div class="widget-content widget-d3timeseries">'
             +  '<table height="100%" width="100%"><tr><td valign="middle" align="center">'
             +  '<span>D3 Timeseries</span>'
             +  '</span></td></tr></table></div>';
        return html;
		
	};

    this.afterLoad = function () {
        this.setSeriesProperties(this.getProperty('NumberOfSeries'), this.getProperty('SingleDataSource'));
        this.setSeriesAxisProperties(this.getProperty('NumberOfSeries'));
    };

    this.afterSetProperty = function (name, value) {
        if (name === 'Width' || name === 'Height') {
            return true;
        }

        if (name.indexOf('YAxisMode') === 0) {
            this.setSeriesAxisProperties(this.getProperty('NumberOfSeries'));
            this.updatedProperties();

            return true;
        }
        
        if (name === 'NumberOfSeries' || name === 'SingleDataSource') {

            this.setSeriesProperties(this.getProperty('NumberOfSeries'), this.getProperty('SingleDataSource'));
            this.updatedProperties();

            return true;
        }
    };
    
    this.beforeSetProperty = function (name, value) {
        if (name === 'NumberOfSeries') {
            value = parseInt(value, 10);
            if (value <= 0 || value > 16)
                return "Number Of Series Must Be Between 1 and 16";
        }
    };

    this.validate = function () {
        var result = [];

        if (!this.isPropertyBoundAsTarget('Data')) {
        	var bound = false;
        	
            for (var seriesNumber = 1; seriesNumber <= this.getProperty('NumberOfSeries'); seriesNumber++) {
                var dsProperty = 'DataSource' + seriesNumber;
                if(this.isPropertyBoundAsTarget(dsProperty)) {
                	bound = true;
                	break;
                }
            }
            
            if(!bound)
            	result.push({ severity: 'warning', message: 'You must assign at least one data source' });
        }
        return result;
    };
    

    this.afterAddBindingSource = function (bindingInfo) {
        if (bindingInfo.targetProperty == "Data") {
            this.setProperty('SingleDataSource', true);

            this.setSeriesProperties(this.getProperty('NumberOfSeries'), this.getProperty('SingleDataSource'));
            this.updatedProperties();
        }
    };
};
