TW.Runtime.Widgets.d3timeseries = function () {

	var initalized = false;
	var chartElementId;
	var canvasGauge;
	var radialGauge;
	var gridContainer;
	var chart;
	this.MAX_SERIES = 16;
    var widgetReference = this;

    this.dynamicSeries = undefined;
    
    this.selectedItems = [];
    
    this.needsManualResize = true;

	this.renderHtml = function () {

		var html = '<div class="widget-content widget-d3timeseries"></div>';
		TW.log.info('# html: ' + html.toString());
		return html;
	};


	this.afterRender = function () {

		this.drawChart(this.getProperty("Data"));

	};


	this.updateProperty = function (updatePropertyInfo) {
		if (updatePropertyInfo.TargetProperty === 'Data') {
			//this.setProperty('GridData', updatePropertyInfo.SinglePropertyValue);
			this.setProperty('Data', updatePropertyInfo.RawDataFromInvoke);
			this.drawChart(updatePropertyInfo.RawDataFromInvoke);
		}
	};
	
	this.resize = function(width,height) {
		TW.log.info('#d3timeseries Entering resize: ');

		const eid = "#"+ chartElementId;
	    $(eid).width(width) ;
		$(eid).height(height) ;
		this.drawChart(this.getProperty("Data"));

	};

	this.init = function () {
		TW.log.info('#d3timeseries Entering init: ');
		
		var domElementId = this.jqElementId;
		var widgetElement = this.jqElement;

		chartElementId = domElementId + '-widget-d3timeseries-container';
		widgetElement.append('<svg  id="' + chartElementId + '" style="width:100%; height:100%;"></svg>');

		gridContainer = this.jqElement.find(chartElementId);

		initalized = true;

	};

	this.drawChart = function (rowData) {
		if (!initalized) {
			TW.log.info('initalized: ' + initalized);
			this.init();
		}

		if (rowData != undefined && rowData != "")  {

			var rowDataArray = rowData.rows;
			//console.log(rowDataArray);
			
			/*const xValue = d => { 
				if (d.temp === undefined) {
					d.temp = 0;
				}
				return d.temp;
			}
			const yValue = d => { 
				if (d.temp === undefined) {
					d.temp = 0;
				}
				return d.temp;
			}*/
			var data = [ {x: 0, y: 00}, {x: 1, y: 30}, {x: 2, y: 40},
            {x: 3, y: 60}, {x: 4, y: 70}, {x: 5, y: 90} ];

			// accessors
			function xValue(d) { return d.x; }
			function yValue(d) { return d.y; }

			const xLabel = this.getProperty("XLegendTitle");
			const yLabel = this.getProperty("YLegendTitle");
			const leftMargin = this.getProperty("LeftMargin");
			const rightMargin = this.getProperty("RightMargin");
			const topMargin = this.getProperty("TopMargin");
			const bottomMargin = this.getProperty("BottomMargin");
			const margin = {
				left: leftMargin,
				right: rightMargin,
				top: topMargin, 
				bottom: bottomMargin
			};
			
			const svg = d3.select('svg');
			svg.selectAll("*").remove();
			
			const eid = "#"+ chartElementId;
			const width = $(eid).width();
			const height = $(eid).height();

			const innerWidth = width - margin.left - margin.right;
			const innerHeight = height - margin.top - margin.bottom;
			
			const g = svg.append('g')
				.attr('transform', `translate(${margin.left},${margin.top})`);
			const xAxisG = g.append('g')
				//commented out next line so that x-axis is on top of chart
				//.attr('transform', `translate(0, ${innerHeight})`);
			const yAxisG = g.append('g');
			xAxisG.append('text')
				.attr('class','axis-label' )
				.attr('x', innerWidth /2)
				.attr('y', -20)
				.style('fill', 'black')
				.text(xLabel);
			yAxisG.append('text')
				.attr('class','axis-label' )
				.attr('x', -innerHeight /2 )
				.attr('y', -60)
			   .attr('transform', `rotate(-90)`)
			   .style('text-anchor', 'middle')
			   .style('fill', 'black')
			   .text(yLabel);

			/*
			// set the ranges
			const xScale = d3.scaleLinear();
			const yScale = d3.scaleLinear();
			
			xScale
				//.domain(d3.extent(data,xValue))
				.domain([0, 5])
				.range([0,innerWidth])
				.nice();
			yScale
				//.domain(d3.extent(data,yValue))
				.domain([0, 20])
				//.range([innerHeight,0])
				//modify y-axis such that it increases top down
				.range([0,innerHeight])
				.nice();
			*/
			
			// interpolator for X axis -- inner plot region
			var x = d3.scaleLinear()
				.domain(d3.extent(data, xValue))
				//.domain([0, 5])
				.range([0,innerWidth])
				.nice();
				
			// interpolator for Y axis -- inner plot region
			var y = d3.scaleLinear()
				.domain(d3.extent(data, yValue))
				//.domain([0, 100])
				//.range([innerHeight,0])
				//modify y-axis such that it increases top down
				.range([0,innerHeight])
				.nice();
				
			//const line = d3.line()
			//.x(d => xScale(d.temp) )
			//.y(d => yScale(d.temp) )
			//.curve(d3.curveBasis);
			
			// SVG line generator
			var line = d3.line()
    			.x(function(d) { return x(d.x); } )
    			.y(function(d) { return y(d.y); } );

			const xAxis = d3.axisBottom()
				.scale(x)
				//.scale(xScale)
				.ticks(5)
				.tickPadding(15)
				.tickSize(-innerHeight)
			const yAxis = d3.axisLeft()
				.scale(y)
				//.scale(yScale)
				.ticks(5)
				.tickPadding(15)
				.tickSize(-innerWidth);
				
			xAxisG.call(xAxis);
			yAxisG.call(yAxis);
			
			//var data = rowDataArray;
			
			// plot the data as a line
			g.append("path")
			    .datum(data)
			    .attr("class", "line")
			    .attr("d", line)
			    .style('fill', 'none')
			    .style('stroke', '#fff')
			  .transition()
			    .delay(500)
			    .duration(1000)
			    .style('stroke', '#000')
			
			// plot a circle at each data location
			g.selectAll(".dot")
    			.data(data)
  			.enter().append("circle")
    			.attr("class", "dot")
    			.attr("cx", function(d) { return x(d.x); } )
    			.attr("cy", function(d) { return y(d.y); } )
    			.attr("r", 5);

			console.log(data);

		//TW.log.info('chart done: ' + chart);

		}
	}

};


// to toggle visibility of an object, try " object.visible = false; "